struct Solution;

impl Solution {
    pub fn compare_version(version1: String, version2: String) -> i32 {
        let mut version1 = version1.split(".").into_iter().map(|x| x.parse().unwrap());
        let mut version2= version2.split(".").into_iter().map(|x| x.parse().unwrap());
        loop {
            match (version1.next(), version2.next()) {
                (Some(version1), version2) if version1 > version2.unwrap_or(0) => return 1,
                (version1, Some(version2)) if version1.unwrap_or(0) < version2 => return -1,
                (None, None) => return 0,
                (_, _) => continue,
            }
        }


    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_compare_version() {
        let version1 = String::from("1.01");
        let version2 = String::from("1.001");
        let res = Solution::compare_version(version1, version2);
        assert_eq!(res, 0);
    }
}