struct Solution;

impl Solution {
    pub fn title_to_number(column_title: String) -> i32 {
        let v = column_title.chars().collect::<Vec<char>>();
        let mut res = 0;
        for (i, &c) in v.iter().rev().enumerate() {
            res += 26_i32.pow(i as u32) * Self::c_to_i(c);
        }

        res
    }

    fn c_to_i(c: char) -> i32 {
        (c as u8 - 'A' as u8) as i32 + 1
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_title_to_number() {
        let column_title = String::from("AB");
        let res = Solution::title_to_number(column_title);
        assert_eq!(res, 28);
    }

    #[test]
    fn test_c_to_i() {
        let res = Solution::c_to_i('B');
        assert_eq!(res, 2);
    }
}